package com.franckbarbier.Single_nesting;

public class Single_nesting {

    protected com.pauware.pauware_engine.Core.AbstractState _Any;
    protected com.pauware.pauware_engine.Core.AbstractState _S1;
    protected com.pauware.pauware_engine.Core.AbstractState _S11;
    protected com.pauware.pauware_engine.Core.AbstractStateMachine _Single_nesting_state_machine;

    private void init_structure() throws com.pauware.pauware_engine.Exceptions.State_exception {
    }

    private void init_behavior() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Any = new com.pauware.pauware_engine.Core.State("Any");
        _Any.inputState();
        _S11 = new com.pauware.pauware_engine.Core.State("S11");
        _S11.set_entryAction(this, "d");
        _S11.doActivity(this, "e");
        _S11.set_exitAction(this, "f");
        _S1 = _S11.and(new com.pauware.pauware_engine.Core.State(com.pauware.pauware_engine.Core.AbstractState.Pseudo_state)).name("S1");
        _S1.set_entryAction(this, "a");
        _S1.doActivity(this, "b");
        _S1.set_exitAction(this, "c");
        _Single_nesting_state_machine = new com.pauware.pauware_engine.Core.StateMachine(_Any.xor(_S1), "Single nesting", com.pauware.pauware_engine.Core.AbstractStateMachine.Don_t_show_on_system_out, new com.pauware.pauware2web.PauWare2Web_client());
    }

    public void start() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Single_nesting_state_machine.fires("e1", _Any, _S1);
        _Single_nesting_state_machine.fires("e2", _S1, _Any);
        _Single_nesting_state_machine.start();
    }

    public void stop() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Single_nesting_state_machine.stop();
    }

    public Single_nesting() throws com.pauware.pauware_engine.Exceptions.State_exception {
        init_structure();
        init_behavior();
    }

    /**
     * UML events
     */
    public void e1() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Single_nesting_state_machine.run_to_completion("e1");
    }

    public void e2() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Single_nesting_state_machine.run_to_completion("e2");
    }

    /**
     * UML actions
     */
    public void a() {
        System.out.println("a executed...");
    }

    public void b() {
        try {
            Thread.sleep(500);
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        }
        System.out.println("b ends...");
    }

    public void c() {
        System.out.println("c executed...");
    }

    public void d() {
        System.out.println("d executed...");
    }

    public void e() {
        try {
            Thread.sleep(100);
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        }
        System.out.println("e ends...");
    }

    public void f() {
        System.out.println("f executed...");
    }

    public static void main(String args[]) {
        try {
            Single_nesting sn = new Single_nesting();
            sn.start();
            sn.e1();
            sn.e2();
            sn.e1();
            sn.stop();
        } catch (Throwable t) {
            t.printStackTrace();
        }
    }
}
